undefine(shift)dnl
#!/bin/sh -e
# Copyright @BABOLO (C)2004 .. 2013 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: srcUP.m4,v 1.46 2017/04/06 19:35:22 babolo Exp $
           ln=/bin/ln
           ls=/bin/ls
           ps=/bin/ps
           rm=/bin/rm
           sh=/bin/sh
          cat=/bin/cat
         date=/bin/date
         kill=/bin/kill
        chmod=/bin/chmod
        mkdir=/bin/mkdir
        sleep=/bin/sleep
     realpath=/bin/realpath
        mount=/sbin/mount
       sysctl=/sbin/sysctl
           id=/usr/bin/id
           tr=/usr/bin/tr
           wc=/usr/bin/wc
          awk=/usr/bin/awk
          env=/usr/bin/env
          sed=/usr/bin/sed
         find=/usr/bin/find
         grep=/usr/bin/grep
         head=/usr/bin/head
         make=/usr/bin/make
         sort=/usr/bin/sort
         tail=/usr/bin/tail
        fetch=/usr/bin/fetch
        lockf=/usr/bin/lockf
        patch=/usr/bin/patch
        uname=/usr/bin/uname
       printf=/usr/bin/printf
      dirname=/usr/bin/dirname
     basename=/usr/bin/basename
     readlink=/usr/bin/readlink
 mkinittmpdir=/usr/bin/mkinittmpdir
           pw=/usr/sbin/pw
        chown=/usr/sbin/chown
          cvs=/usr/local/bin/cvs
          su2=/usr/local/bin/su2
          svn=/usr/local/bin/svn
        cvsup=/usr/local/bin/cvsup
      svnlook=/usr/local/bin/svnlook
      svnsync=/usr/local/bin/svnsync
      wait_on=/usr/local/bin/wait_on
     svnadmin=/usr/local/bin/svnadmin

    groupfile=/etc/group
     passfile=/etc/passwd
        suser=CVShome
        su_id=65536
      tmplock=/tmp/srcUP.lock
       cvsdir=/home/${suser}/`${uname}`
       svndir=/home/SVNhome/`${uname}`
      svnddir=/home/SVNhome/`${uname}`/doc
      svnbdir=/home/SVNhome/`${uname}`/base
      svnpdir=/home/SVNhome/`${uname}`/ports
      svndsrc=file://${svnddir}
      svnbsrc=file://${svnbdir}
      svnpsrc=file://${svnpdir}
        rodir=/usr
      srcdir0=/usr/src
     portsdir=/usr/ports
     localdir=/home/LOCAL
       cvserv=anoncvs@cvs.babolo.ru:/repo
 FreeBSDCVSup=cvsup4.ru.FreeBSD.org
 FreeBSDSVNup=svn://svn.FreeBSD.org
       supdir=/var/net/sup
       myname=`${realpath} "${0}"`
        osver="`${uname} -r | ${sed} -Ee 's|[^0-9].*$||'`"
      procver="`${uname} -p`"

if  [ -e `${dirname} BINDIR`/etc/srcUP.conf ]; then
    . `${dirname} BINDIR`/etc/srcUP.conf
fi

a="`${dirname} ${myname}`"
if  [ -e `${dirname} "${a}"`/etc/srcUP.conf ]; then
    . `${dirname} "${a}"`/etc/srcUP.conf
fi

if  [ "${baseversrcdir}" = "" ]; then
    srcdir="${srcdir0}"
else
    srcdir="${baseversrcdir}${osver}"
fi

if  [ -n "${ARCH}" ] ; then
    SETARCH="ARCH=${ARCH}"
else
    SETARCH=
fi

helpout() {
    ${cat} <<- EOF
	srcUP @BABOLO V.M `${cat} BUILDINCLUDEDIR/srcUP.VERSION` + VERS
	Usage:
	  srcUP config   - make config in loop
	  srcUP install  - make install in loop
	  srcUP checkall - check all distfiles
	  srcUP cvs [host [subdir [repo]...]] - ${cvsdir} update
	  srcUP svnd     - ${svnddir} update
	  srcUP svnb     - ${svnbdir} update
	  srcUP svnp     - ${svnpdir} update
	  srcUP svn      - ${svnddir}, ${svnbdir}, ${svnpdir} update
	  srcUP fetch    - fetch ports and dependencies distfiles
	  srcUP fetchall - fetch all distfiles
	  srcUP local    - ${localdir} update
	  srcUP lock [cvs|svnd|svnb|svnp|src|ports|local|[0-9]*] [text]
	      - lock indicated or ${cvsdir} and ${srcdir}
	  srcUP new [N]  - initialisation
	  srcUP patchports - patches ports by local patches
	  srcUP patchsrc [N] - patches OS sources by local patches
	  srcUP ports    - ${portsdir} update
	  srcUP src      - all OS sources update
	  srcUP N        - FreeBSD N sources update
	  srcUP stat     - update dates list
	  srcUP unlock [cvs|svnd|svnb|svnp|src|ports|local|[0-9]*]
	      - unlock indicated or ${cvsdir} and ${srcdir}
EOF
}

if  [ -z "${cmd:=${1}}" ]; then
    helpout
    exit
fi
shift

patchportslist="\
    ports.Mk.port.mk\
    ports.TMPDIR\
    ports.graphics.hobbes-icons-xpm\
"

osverlist="2_2 2 3 4 5 6 7 8"
soverlist="2.0.5 2.1 2.2 2 3 4 5 6 7 8 9 10 11 12 13 14 15"

trap 'r="$?"; if [ "${r}" -eq "75" ]; then echo -n "Locked: "; ${ls} -l ${tmplock}; fi; exit ${r}' EXIT

patchsrclist4="                               \
    src.contrib.libpcap.pcap-bpf              \
    src.etc.mtree.var                         \
    src.etc                                   \
    src.gnu.usr.bin.man.man                   \
    src.sbin.route                            \
    src.share.skel                            \
    src.share.syscons.fonts.koi8-r-thin-8x8   \
    src.sys.dev.drm.radeon                    \
    src.sys.kern.subr                         \
    src.sys.miscfs.nullfs                     \
    src.sys.modules.Makefile                  \
    src.sys.netinet                           \
    src.sys.softdep                           \
    src.sys.ufs.ffs.ffs_alloc                 \
    src.usr.bin.mkinittmpdir                  \
    src.usr.sbin.arp                          \
"
patchsrclist7="                               \
    src.contrib.libpcap.pcap-bpf              \
    src.etc.mtree.var                         \
    src.etc                                   \
    src.etc.periodic.security                 \
    src.etc.rc.d                              \
    src.gnu.usr.bin.man.man                   \
    src.sbin.bsdlabel.c                       \
    src.share.skel                            \
    src.share.syscons.fonts.koi8-r-thin-8x8   \
    src.sys.dev.drm.drm_pciids                \
    src.sys.netinet                           \
    src.usr.bin.mkinittmpdir                  \
    src.usr.sbin.arp                          \
"
patchsrclist8="                               \
    src.etc.mtree.var                         \
    src.etc                                   \
    src.share.skel                            \
    src.share.syscons.fonts.koi8-r-thin-8x8   \
    src.sys.netinet                           \
    src.usr.bin.mkinittmpdir                  \
"
patchsrclist9="                               \
    src.etc.mtree.var                         \
    src.etc                                   \
    src.share.skel                            \
    src.share.syscons.fonts.koi8-r-thin-8x8   \
    src.sys.netinet                           \
    src.usr.bin.mkinittmpdir                  \
"

patchsrclist10="                              \
    src.contrib.sendmail                      \
    src.crypto.heimdal.lib.krb5.addr_families \
    src.crypto.openssh.sshconnect             \
    src.etc.mtree.var                         \
    src.etc                                   \
    src.sbin.routed.if                        \
    src.share.skel                            \
    src.share.syscons.fonts.koi8-r-thin-8x8   \
    src.sys.net.flowtable                     \
    src.sys.netinet                           \
    src.sys.netpfil.pf                        \
    src.usr.bin.man.man                       \
    src.usr.bin.mkinittmpdir                  \
    src.usr.bin.sockstat                      \
"

makeopts="                       \
    ALLOW_UNSUPPORTED_SYSTEM=YES \
    AP_IGNORE_VERSION_CHECK=YES  \
    DISABLE_VULNERABILITIES=YES  \
    DISABLE_SECURITY_CHECK=YES   \
    DISABLE_CONFLICTS=YES        \
    DISABLE_LICENSES=YES         \
    WARNING_WAIT=0               \
    TRYBROKEN=YES                \
    NO_IGNORE=YES                \
    ${SETARCH}                   \
"

u=`${id} -un`

svndx() {
    EXELOCT(svnd,dnl
        ${svnsync} sync file://${svnddir}
        STAMP(${svnddir}/.srcUP.history)
)dnl
}

svnbx() {
    EXELOCT(svnb,dnl
        ${svnsync} sync file://${svnbdir}
        STAMP(${svnbdir}/.srcUP.history)
)dnl
}

svnpx() {
    EXELOCT(svnp,dnl
        ${svnsync} sync file://${svnpdir}
        STAMP(${svnpdir}/.srcUP.history)
)dnl
}

case ${cmd} in
config)
    while :; do
        read -p 'config->' i
        case ${i} in
        '')
            if  [ "${ii}" != "" ]; then
                cd "${ii}"
                echo "                   ----------------------====================== ${ii}"
                ${cat} pkg-descr
            fi
            ;;
        ${portsdir}/*)
            if  [ -d "${i}" ]; then
                cd "${i}"
                ${su2} -- ${make} ${makeopts} config-recursive
                ii="${i}"
            fi
            ;;
        *)
            if  [ -d "${portsdir}/${i}" ]; then
                cd "${portsdir}/${i}"
                ${su2} -- ${make} ${makeopts} config-recursive
                ii="${i}"
            else
                ii=''
            fi
            ;;
        esac
    done
    ;;
install)
    while :; do
        f=''
        read -p 'install->' i
        case ${i} in
        '')
            echo "install->${ii}"
            if  [ "${ii}" != "" ]; then
                i="${ii}"
                f='FORCE_PKG_REGISTER=YES'
            fi
            ;;
        ${portsdir}/*)
            ;;
        *)
            if  [ -d "${portsdir}/${i}" ]; then
                i="${portsdir}/${i}"
            fi
            ;;
        esac
        if  [ -d "${i}" ]; then
            cd "${i}"
            ${su2} -- ${sh} -c "${mount} -uw ${rodir} ; ${make} ${makeopts} install ${f} ; ${mount} -ur ${rodir}"
            ii="${i}"
        else
            ii=''
        fi
    done
    ;;
src)            #######################################################################################
    if  [ -n "${1}" ]; then
        svnbsrc="${1}"
    fi
    if  [ "${baseversrcdir}" = "" ]; then
        if  [ -d ${srcdir}/.svn ]; then
            srcx() {
                EXELOCK(svnb,src,dnl
                    cd ${srcdir}
                    ${svn} up
                    STAMP(${srcdir}/.srcUP.history)
)          }
            WAITON(srcx)
        elif [ -d ${srcdir}/CVS ]; then
            srcx() {
                EXELOCK(cvs,src,dnl
                    cd ${srcdir}
                    ${cvs} -qR up -dP
                    STAMP(${srcdir}/.srcUP.history)
)          }
            WAITON(srcx)
        elif [ -d ${srcdir} ]; then
            srcx() {
                EXELOCK(svnb,src,dnl
                    ${svn} co ${svnbsrc}/stable/${osver} ${srcdir}
                    STAMP(${srcdir}/.srcUP.history)
)          }
            WAITON(srcx)
        fi
    else
        for i in ${soverlist}; do
            srcdir="${baseversrcdir}${i}"
            if  [ -d ${srcdir}/.svn ]; then
                srcx() {
                    EXELOCK(svnb,src,dnl
                        cd ${srcdir}
                        ${svn} up
                        STAMP(${srcdir}/.srcUP.history)
)              }
                WAITON(srcx)
            elif [ -d ${srcdir}/CVS ]; then
            elif [ -d ${srcdir} ]; then
                srcx() {
                    EXELOCK(svnb,src,dnl
                        ${svn} co ${svnbsrc}/stable/${i} ${srcdir}
                        STAMP(${srcdir}/.srcUP.history)
)              }
                WAITON(srcx)
            fi
        done
        for i in ${osverlist}; do
            srcdir="${baseversrcdir}${i}"
            if  [ -d ${srcdir}/CVS ]; then
                srcx() {
                    EXELOCK(cvs,src,dnl
                        cd ${srcdir}
                        ${cvs} -qR up -dP
                        STAMP(${srcdir}/.srcUP.history)
)              }
                WAITON(srcx)
            fi
        done
    fi
    ;;
0*|1*|2*|3*|4*|5*|6*|7*|8*|9*) ########################################################################
    if  [ -n "${1}" ]; then
        svnbsrc="${1}"
    fi
    if  [ "${baseversrcdir}" = "" ]; then
        ERROR(1,"Error: \$baseversrcdir is not defined")
    fi
    srcdir="${baseversrcdir}${cmd}"
    if  [ -d ${srcdir}/.svn ]; then
        srcN() {
            EXELOCK(svnb,src,dnl
                cd ${srcdir}
                ${svn} up
                STAMP(${srcdir}/.srcUP.history)
)      }
        WAITON(srcN)
    elif [ -d ${srcdir}/CVS ]; then
        srcN() {
            EXELOCK(cvs,src,dnl
                cd ${srcdir}
                ${cvs} -qR up -dP
                STAMP(${srcdir}/.srcUP.history)
)      }
        WAITON(srcN)
    elif [ -d ${srcdir} ]; then
        srcN() {
            EXELOCK(svnb,src,dnl
                ${svn} co ${svnbsrc}/stable/${cmd} ${srcdir}
                STAMP(${srcdir}/.srcUP.history)
)      }
        WAITON(srcN)
    else
        echo "${srcdir} is not CVS or SVN dir"
        exit 1
    fi
    ;;
ports)          #######################################################################################
    if  [ -n "${1}" ]; then
        svnpsrc="${1}"
    fi
    if  [ -d ${portsdir}/.svn ]; then
        portsx() {
            EXELOCK(svnp,ports,dnl
                cd ${portsdir}
                ${svn} up
                STAMP(${portsdir}/.srcUP.history)
)      }
        WAITON(portsx)
    elif [ -d ${portsdir}/CVS ]; then
        portsx() {
            EXELOCK(cvs,ports,dnl
                cd ${portsdir}
                ${cvs} -qR up -dAP
                STAMP(${portsdir}/.srcUP.history)
)      }
        WAITON(portsx)
    elif [ -d ${portsdir} ]; then
        portsx() {
            EXELOCK(svnp,ports,dnl
                ${svn} co ${svnpsrc}/head ${portsdir}
                STAMP(${portsdir}/.srcUP.history)
)      }
        WAITON(portsx)
    else
        echo "${portsdir} is not CVS or SVN dir"
        exit 1
    fi
    ;;
local)          #######################################################################################
    if  [ -n "${1}" ]; then
        osver="${1}"
    fi
    localx() {
        EXELOCK(local,dnl
            cd \"${localdir}\"
            if  [ ! -e usr ]; then
            elif [ ! -L usr ]; then
                ${rm} -rf usr
            elif [ \"\\\\\\\`${readlink} usr\\\\\\\`\" != \".\" ]; then
                ${rm} -f usr
            fi
            if  [ ! -e usr ]; then
                ${ln} -s . usr
            fi
            if  [ ! -e ports ]; then
            elif [ ! -L ports ]; then
                ${rm} -rf ports
            elif [ \"\\\\\\\`${readlink} ports\\\\\\\`\" != \".\" ]; then
                ${rm} -f ports
            fi
            if  [ ! -e ports ]; then
                ${ln} -s . ports
            fi
            for i in \\\\\\\`${find} . -type l\\\\\\\`; do
                if  [ ! -e \"\\\\\\\${i}\" ]; then ${rm} -f \"\\\\\\\${i}\"; fi
            done
            ${cvs} -qR up -dAP
            if  [ -f MAKE ]; then ${sh} -e MAKE in ${osver} 1>&2; fi
            STAMP(${localdir}/.srcUP.history)
)  }
    WAITON(localx)
    ;;
patchsrc)       #######################################################################################
    if  [ -n "${1}" ]; then
        osver="${1}"
    fi
    eval patchsrclist="\${patchsrclist${osver}}"
    if  [ "${baseversrcdir}" != "" ]; then
        srcdir="${baseversrcdir}${osver}"
    fi
 
    patchsrcx() {
        EXELOCK(src,dnl
            ${rm} -rf ${TMPDIR}/ports/NON_ports/patchFBSD${osver}
            GETOTMP(ports/NON_ports/patchFBSD${osver})
            ${mkdir} -p ${srcdir}/usr.bin/mkinittmpdir
            for i in ${patchsrclist}; do
                ERROR(,\\\\\\\${i})
                if ! ${patch} -Esd ${srcdir} -i \${TMPDIR}/ports/NON_ports/patchFBSD${osver}/\\\\\\\${i}.patch
                then
                    ERROR(,\"Error: \\\\\\\${i}.patch\")
                fi
            done
            ${find} ${srcdir} -name '*.orig' -print -delete
)  }
    WAITON(patchsrcx)
    ;;
patchports)     #######################################################################################
    patchportsx() {
        EXELOCK(ports,dnl
            ${rm} -rf ${TMPDIR}/ports/NON_ports/patchFBSD
            GETOTMP(ports/NON_ports/patchFBSD)
            for i in ${patchportslist}; do
                ERROR(,\\\\\\\${i})
                if ! ${patch} -Esd ${portsdir} -i \${TMPDIR}/ports/NON_ports/patchFBSD/\\\\\\\${i}.patch; then
                    ERROR(,\"Error: \\\\\\\${i}.patch\")
                fi
            done
            ${find} ${portsdir} -name '*.orig' -print -delete
)  }
    WAITON(patchportsx)
    ;;
stat|look)      #######################################################################################
    EXEUSER(LOOKLOCK(cvs,		))dnl
    EXEUSER(LOOKLOCK(svnd,	))dnl
    EXEUSER(LOOKLOCK(svnb,	))dnl
    EXEUSER(LOOKLOCK(svnp,	))dnl
    if  [ "${baseversrcdir}" = "" ]; then
        EXEUSER(LOOKLOCK(src,       			))dnl
    else
        for i in ${osverlist}; do
            srcdir="${baseversrcdir}${i}"
            if  [ -d ${srcdir}/CVS ]; then
                EXEUSER(LOOKLOCK(src,       			))dnl
            fi
        done
        for i in ${soverlist}; do
            srcdir="${baseversrcdir}${i}"
            if  [ -d ${srcdir}/.svn ]; then
                EXEUSER(LOOKLOCK(src,       			))dnl
            fi
        done
    fi
    EXEUSER(dnl
        LOOKLOCK(ports,     			)
        LOOKLOCK(local,    			)
        ERROR(,)
        LOOKHIST(cvs,		)
        LOOKHISS(svnd,	)
        LOOKHISS(svnb,	)
        LOOKHISS(svnp,	)
)dnl
    if  [ "${baseversrcdir}" = "" ]; then
        srcdir="${srcdir0}"
        if  [ -d ${srcdir}/.svn ]; then
            EXEUSER(LOOKHITS(src,       			))dnl
        else
            EXEUSER(LOOKHIST(src,       			))dnl
        fi
    else
        for i in ${osverlist}; do
            srcdir="${baseversrcdir}${i}"
            if  [ ! -d ${srcdir}/.svn ]; then
                EXEUSER(LOOKHIST(src,       			))dnl
            fi
        done
        for i in ${soverlist}; do
            srcdir="${baseversrcdir}${i}"
            if  [ -d ${srcdir}/.svn ]; then
                EXEUSER(LOOKHITS(src,       			))dnl
            fi
        done
    fi
    if  [ -d ${portsdir}/.svn ]; then
        EXEUSER(LOOKHITS(ports,       		))dnl
    else
        EXEUSER(LOOKHIST(ports,     			))dnl
    fi
    EXEUSER(LOOKHIST(local,    			))dnl
    ;;
fetch)          #######################################################################################
    list="$@"
    fetchx() {
        EXELOCK(${make} ${makeopts} fetch-recursive ${list})
    }
    t=0
    for i in `${make} -V SUBDIR "${@}"`; do
        t=$(( ${t} + 1 ))
        (cd ${i}; "${myname}" fetch "${@}")
    done
    if  [ ${t} -eq 0 ]; then
        WAITON(fetchx)
    fi
    ;;
lock)           #######################################################################################
    if  [ -n "${knd:=${1}}" ]; then shift; fi
    case "${knd}" in
    cvs)
        EXEPRIV(${suser}, LOCK(cvs, $*))
        ;;
    svnd)
        EXEPRIV(${suser}, LOCK(svnd, $*))
        ;;
    svnb)
        EXEPRIV(${suser}, LOCK(svnb, $*))
        ;;
    svnp)
        EXEPRIV(${suser}, LOCK(svnp, $*))
        ;;
    src)
        if  [ "${baseversrcdir}" = "" ]; then
            EXEPRIV(${suser}, LOCK(src, $*))
        else
            verlist="`echo ${osverlist} ${soverlist} | ${sort} -u`"
            for i in ${verlist}; do
                srcdir="${baseversrcdir}${i}"
                if  [ -d ${srcdir} ]; then
                    EXEPRIV(${suser}, LOCK(src, $*))
                fi
            done
        fi
        ;;
    0*|1*|2*|3*|4*|5*|6*|7*|8*|9*)
        if  [ "${baseversrcdir}" = "" ]; then
            ERROR(1,"Error: \$baseversrcdir is not defined")
        fi
        srcdir="${baseversrcdir}${knd}"
        if  [ -d ${srcdir} ]; then
            EXEPRIV(${suser}, LOCK(src, $*))
        fi
        ;;
    ports)
        EXEPRIV(${suser}, LOCK(ports, $*))
        ;;
    local)
        EXEPRIV(${suser}, LOCK(local, $*))
        ;;
    '')
        EXEPRIV(${suser},dnl
            LOCK(cvs, "")
            LOCK(src, "")
)dnl
        ;;
    *)
        ERROR(1,"Error: ${1}: unknown lock")
        ;;
    esac
    ;;
unlock)         #######################################################################################
    case "${1}" in
    cvs)
        EXEPRIV(${suser},dnl
            LOCK(cvs)
            ${rm} -f ${cvsdir}/.srcUP.lock
)dnl
        ;;
    svnd)
        EXEPRIV(${suser},dnl
            LOCK(svnd)
            ${rm} -f ${svnddir}/.srcUP.lock
)dnl
        ;;
    svnb)
        EXEPRIV(${suser},dnl
            LOCK(svnb)
            ${rm} -f ${svnbdir}/.srcUP.lock
)dnl
        ;;
    svnp)
        EXEPRIV(${suser},dnl
            LOCK(svnp)
            ${rm} -f ${svnpdir}/.srcUP.lock
)dnl
        ;;
    src)
        if  [ "${baseversrcdir}" = "" ]; then
            EXEPRIV(${suser},dnl
                LOCK(src)
                ${rm} -f ${srcdir}/.srcUP.lock
)dnl
        else
            verlist="`echo ${osverlist} ${soverlist} | ${sort} -u`"
            for i in ${verlist}; do
                srcdir="${baseversrcdir}${i}"
                if  [ -d ${srcdir} ]; then
                    EXEPRIV(${suser},dnl
                        LOCK(src)
                        ${rm} -f ${srcdir}/.srcUP.lock
)dnl
                fi
            done
        fi
        ;;
    0*|1*|2*|3*|4*|5*|6*|7*|8*|9*)
        if  [ "${baseversrcdir}" = "" ]; then
            ERROR(1,"Error: \$baseversrcdir is not defined")
        fi
        srcdir="${baseversrcdir}${1}"
        if  [ -d ${srcdir} ]; then
            EXEPRIV(${suser},dnl
                LOCK(src)
                ${rm} -f ${srcdir}/.srcUP.lock
)dnl
        fi
        ;;
    ports)
        EXEPRIV(${suser},dnl
            LOCK(ports)
            ${rm} -f ${portsdir}/.srcUP.lock
)dnl
        ;;
    local)
        EXEPRIV(${suser},dnl
            LOCK(local)
            ${rm} -f ${localdir}/.srcUP.lock
)dnl
        ;;
    '')
        EXEPRIV(${suser},dnl
            LOCK(cvs)
            LOCK(src)
            ${rm} -f ${srcdir}/.srcUP.lock
            ${rm} -f ${cvsdir}/.srcUP.lock
)dnl
        ;;
    *)
        ERROR(1,"Error: ${1}: unknown lock")
        ;;
    esac
    ;;
cvs)            #######################################################################################
    n3="${3:-cvs-all}"
    if  [ -n "${1}" ]; then
        FreeBSDCVSup="${1}"
        if  [ -n "${2}" ]; then
            cvsdir="`${dirname} ${cvsdir}`/${2}"
            n4="${4}"
            n5="${5}"
            n6="${6}"
            n7="${7}"
            n8="${8}"
            n9="${9}"
            n10="${10}"
            n11="${11}"
            n12="${12}"
    fi; fi

    cvsx() {
        EXELOCT(cvs,
            ${cvsup} -gL2 /dev/stdin <<- EOP
		*default host=${FreeBSDCVSup}
		*default base=`${dirname} ${supdir}`
		*default prefix=${cvsdir}
		*default release=cvs
		*default delete use-rel-suffix
		#*default compress

		${n3}
		${n4}
		${n5}
		${n6}
		${n7}
		${n8}
		${n9}
		${n10}
		${n11}
		${n12}
EOP
            STAMP(${cvsdir}/.srcUP.history)
)  }
    WAITON(cvsx)
    ;;
svnd)           #######################################################################################
    WAITON(svndx)
    ;;
svnb)           #######################################################################################
    WAITON(svnbx)
    ;;
svnp)           #######################################################################################
    WAITON(svnpx)
    ;;
svn)            #######################################################################################
    WAITON(svndx)
    WAITON(svnbx)
    WAITON(svnpx)
    ;;
new)            #######################################################################################
    if  [ -n "${1}" ]; then
        osver="${1}"
    fi
    EXEPRIV(root,dnl
        if ! ${grep} -q "^${suser}:" ${groupfile}; then
            EXERR(1, ${pw} groupadd ${suser} -qg ${su_id})
        fi
        if ! ${grep} -q "^${suser}:" ${passfile}; then
            EXERR(1, ${pw} useradd ${suser} -qu ${su_id} -g ${su_id} -c 'CVS owner' -w no)
        fi
        ${mkdir} -p ${cvsdir} ${srcdir} ${portsdir} ${localdir} ${supdir}
        ${mkdir} -p `${dirname} ${cvsdir}`/.desk `${dirname} ${cvsdir}`/.ssh
        if  [ -d "${localdir}/CVS" ]; then
            TSTFILL(local, CVS/Root, ${cvserv}/ports)
            TSTFILL(local, CVS/Repository, .)
        else
            ${mkdir} "${localdir}/CVS"
            UFILL(local, CVS/Root, ${cvserv}/ports)
            UFILL(local, CVS/Repository, .)
            UFILL(local, CVS/Entries, )
        fi
        if  [ ! -f /etc/make.conf ]; then
            ${cat} <<- "EOFMK" > /etc/make.conf
		#MASTER_SITE_OVERRIDE?= ftp://ftp2.ru.freebsd.org/pub/FreeBSD/ports/distfiles/\${DIST_SUBDIR}/
		MASTER_SITE_OVERRIDE?= http://free.babolo.ru/ports/distfiles/\${DIST_SUBDIR}/
		
		PACKAGES=\${TMPDIR}
		WRKDIRPREFIX=\${TMPDIR}
		MAKEOBJDIRPREFIX?=\${TMPDIR}
		LOCAL_PATCHDIR_PREFIX?=/home/LOCAL
		
		USA_RESIDENT	= NO
		HAVE_UNISYS_LICENSE=YES
		HAVE_MOTIF	= YES
		WITH_ALL	= YES
		
		BOOT_COMCONSOLE_SPEED= 115200
		PORTS_AUDIT	= YES
		WITHOUT_X11	= YES
		MAKE_IDEA	= YES	# IDEA (128 bit symmetric encryption)
		#SENDMAIL_CFLAGS	= -I/usr/local/include/sasl -DSASL
		CVS_UPDATE	= YES
		CVSROOT 	= /home/CVShome
		
		.if \${.CURDIR:N*/ports/net/mtr} == ""
		WITHOUT_X11	= YES
		.endif
EOFMK
        fi
        ${mkdir} -p ${svnddir} ${svnbdir} ${svnpdir}
        ${chown} -R "${suser}:${suser}" ${svndir}
        ${chown} -R "${suser}:${suser}" ${cvsdir} ${srcdir} ${portsdir} ${localdir} ${supdir}
        ${chown} -R "${suser}:${suser}" `${dirname} ${cvsdir}`/.desk `${dirname} ${cvsdir}`/.ssh
        if  [ ! -e "/sys" -a ! -L "/sys" ]; then
            ln -s "`echo "${srcdir}/sys" | sed -e 's|^/||'`" /sys
        elif  [ ! -L /sys ]; then
            ERROR(1,"Error: /sys is not a link")
        elif [ "\`${readlink} /sys\`" != "`echo "${srcdir0}/sys" | sed -e 's|^/||'`" ]; then
            ERROR(1,"Error: /sys is not a link to `echo "${srcdir0}/sys" | sed -e 's|^/||'`")
        fi
)dnl
    EXEPRIV(${suser},dnl
        if  [ ! -e ${svnddir}/format ]; then
            ${svnadmin} create --fs-type fsfs ${svnddir}
            ${cat} <<- EOF > ${svnddir}/hooks/pre-revprop-change
		#!/bin/sh
		exit 0
EOF
            ${chmod} a+x ${svnddir}/hooks/pre-revprop-change
            ${svnsync} init ${svndsrc} ${FreeBSDSVNup}/doc
        fi
        if  [ ! -e ${svnbdir}/format ]; then
            ${svnadmin} create --fs-type fsfs ${svnbdir}
            ${cat} <<- EOF > ${svnbdir}/hooks/pre-revprop-change
		#!/bin/sh
		exit 0
EOF
            ${chmod} a+x ${svnbdir}/hooks/pre-revprop-change
            ${svnsync} init ${svnbsrc} ${FreeBSDSVNup}/base
        fi
        if  [ ! -e ${svnpdir}/format ]; then
            ${svnadmin} create --fs-type fsfs ${svnpdir}
            ${cat} <<- EOF > ${svnpdir}/hooks/pre-revprop-change
		#!/bin/sh
		exit 0
EOF
            ${chmod} a+x ${svnpdir}/hooks/pre-revprop-change
            ${svnsync} init ${svnpsrc} ${FreeBSDSVNup}/ports
        fi

)dnl
    newx() {
        EXELOCK(local,dnl
            cd ${localdir}
            for i in usr ports ; do
                if  [ -L \\\\\\\${i} ]; then
                    if  [ \"\\\\\\\`${readlink} \\\\\\\${i}\\\\\\\`\" != '.' ]; then
                        ERROR(1,\"Error: \\\\\\\${i} is not a link to '.'\")
                    fi
                elif [ -e \\\\\\\${i} ]; then
                    ERROR(1,\"Error: \\\\\\\${i} exists but not a link\")
                else
                    ${ln} -s . \\\\\\\${i}
                fi
            done
)  }
    WAITON(newx)
    ;;
checkall)       #######################################################################################
    cd ${portsdir}
    if  [ -z "${1}" ] ; then
        list=` ${ls}\
             | ${grep} -vE '^(CVS|distfiles|pkg|Mk|Templates|Tools)$'\
             | ${tr} '\n' ' '
             `
    else
        list="$@"
    fi
    checkallx() {
        EXELOCK(ports,dnl
            for j in ${list}; do
                if  [  -d \"${portsdir}/\\\\\\\${j}\" ] ; then
                    cd \"${portsdir}/\\\\\\\${j}\"
                    for i in \\\\\\\`${ls} | ${grep} -vE '^(CVS|pkg)$'\\\\\\\` ; do
                        if  [ -d \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\" ] ; then
                            cd \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\"
                            ERROR(,\"                   ----------------------====================== \\\\\\\${j}/\\\\\\\${i}\")
                              ( echo ; echo ; TBN ; TBN ; TBN ; TBN )\
                            | ${make} ${makeopts} BATCH=YES checksum 1>&2 || :
                        fi
                    done
                fi
            done
)  }
    WAITON(checkallx)
    ;;
fetchall)       #######################################################################################
    cd ${portsdir}
    e1="0"
    l1="-10"
    f1="-f50"
    while [ "${1}" != "${1#-}" ]; do
        case "${1}" in
        -q)
            e1="1"
            shift
            ;;
        -[0-9]*)
            l1="${1}"
            shift
            ;;
        -f*)
            f1="${1}"
            shift
            ;;
        -*)
            shift
            ;;
        esac
    done
    f1="${f1#-f}"
    l1=$(( 0 - ${l1} * 100 ))
    export srcUP_LOAD="load=\$(( \`${ps} -ax | ${grep} -E ' ${fetch} | fetch: ' | ${wc} -l\` * $f1 + \`${env} LC_ALL=C ${sysctl} -n vm.loadavg | ${awk} '{sub(\"\\\\\\\\.\", \"\", \\\$2); sub(\"^0+\", \"\", \\\$2); print \\\$2 + 0}'\` ))"
    if  [ -z "${1}" ] ; then
        list=` ${ls} -l\
             | ${grep} -v '^total '\
             | ${awk} '{print $2 " " $9}'\
             | ${sed} -e 's|^\([0-9]\) |    \1 |'\
                      -e 's|^\([0-9][0-9]\) |   \1 |'\
                      -e 's|^\([0-9][0-9][0-9]\) |  \1 |'\
                      -e 's|^\([0-9][0-9][0-9][0-9]\) | \1 |'\
             | ${sort} -r\
             | ${awk} '{print $2}'\
             | ${grep} -vE '^(CVS|distfiles|pkg|Mk|Templates|Tools)$'\
             | ${tr} '\n' ' '
             `
    else
        list="$@"
    fi
    if  [ -n "${ARCH}" ] ; then
        SETARCH="ARCH=${ARCH}"
    else
        SETARCH=
    fi
    fetchallx() {
        EXELOCK(ports,dnl
            for j in ${list}; do
                if  [  -d \"${portsdir}/\\\\\\\${j}\" ] ; then
                    cd \"${portsdir}/\\\\\\\${j}\"
                    for i in \\\\\\\`${ls} | ${grep} -vE '^(CVS|pkg)$'\\\\\\\` ; do
                        if  [ -d \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\" ] ; then
                            cd \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\"
                            (   ERROR(,\"HR \\\\\\\${j}/\\\\\\\${i}\")
                                ${make} ${makeopts} BATCH=YES fetch 1>&2 || :
                              ( echo ; echo ; TBN ; TBN ; TBN ; TBN )\
                            | ${make} ${makeopts} fetch 1>&2 || :
                            ) &
                            eval ${srcUP_LOAD}
                            while [ \"\\\\\\\${load}\" -ge \"${l1}\" ]; do
                                if  [ \"${e1}\" = \"0\" ]; then ERROR(,\"  5 \") fi
                                ${sleep} 5
                                eval ${srcUP_LOAD}
                            done
                            ${sleep} 0.1
                        fi
                    done
                fi
            done
            wait
)  }
    WAITON(fetchallx)
    ;;
*)              #######################################################################################
    helpout
    exit 64
    ;;
esac
